use std::fs;

use rayon::prelude::*;
use scan_fmt::scan_fmt;

pub fn solve() {
    let path = "res/14/input";

    const WIDTH: isize = 101;
    const HEIGHT: isize = 103;

    #[allow(unused)]
    let contents = fs::read_to_string(path).expect("Something went wrong reading the file");

    let robots_orig: Vec<((isize, isize), (isize, isize))> = contents
        .lines()
        .map(|l| {
            let (px, py, vx, vy) =
                scan_fmt!(l, "p={},{} v={},{}", isize, isize, isize, isize).unwrap();
            ((px, py), (vx, vy))
        })
        .collect();

    let mut robots = robots_orig.clone();

    robots.iter_mut().for_each(|r| {
        for _ in 0..100 {
            let ((px, py), (vx, vy)) = r;
            *px += *vx;
            *py += *vy;
            if *px < 0 {
                *px += WIDTH;
            }
            if *py < 0 {
                *py += HEIGHT;
            }
            *px %= WIDTH;
            *py %= HEIGHT;
        }
    });

    let q1 = robots
        .iter()
        .filter(|((x, y), (_, _))| *x < (WIDTH / 2) && *y < (HEIGHT / 2))
        .count();
    let q2 = robots
        .iter()
        .filter(|((x, y), (_, _))| *x > (WIDTH / 2) && *y < (HEIGHT / 2))
        .count();
    let q3 = robots
        .iter()
        .filter(|((x, y), (_, _))| *x < (WIDTH / 2) && *y > (HEIGHT / 2))
        .count();
    let q4 = robots
        .iter()
        .filter(|((x, y), (_, _))| *x > (WIDTH / 2) && *y > (HEIGHT / 2))
        .count();

    let result = q1 * q2 * q3 * q4;

    println!("Result 1: {}", result);

    let mut robots = robots_orig.clone();

    /*
    for i in 0..10000 {
        robots.iter_mut().for_each(|r| {
            let ((px, py), (vx, vy)) = r;
            *px += *vx;
            *py += *vy;
            if *px < 0 {
                *px += WIDTH;
            }
            if *py < 0 {
                *py += HEIGHT;
            }
            *px %= WIDTH;
            *py %= HEIGHT;
        });
        // print
        if (i - 539) % 103 != 0 {
            continue;
        }
        println!("\nSECOND: {}", i + 1);
        for y in 0..HEIGHT {
            for x in 0..WIDTH {
                if robots.iter().any(|((px, py), _)| *px == x && *py == y) {
                    print!("#");
                } else {
                    print!(".");
                }
            }
            println!();
        }
    }
    */

    let result: usize = 7338;

    println!("Result 2: {}", result);
}
